#include <avr/io.h>

#define del_led 0x5ffff

void delay (unsigned int del_time);
void LEDOn(int led);
void LEDOff(int led);

int main(void)
{
  int i;

  DDRC=0xff;			// all PORTC pins are outputs

  while (1)
  {
      for (i = 0; i < 8; ++i)
      { 
	    LEDOn(i);
        delay(del_led);
      } 
      for (i = 0; i < 8; ++i)
      { 
        LEDOff(i);
        delay(del_led);
      } 
      for (i = 7; i >= 0; --i)
      { 
        LEDOn(i);
        delay(del_led);
      } 
      for (i = 7; i >= 0; --i)
      { 
        LEDOff(i);
        delay(del_led);
      }
  } // while
}
/////////////////////////////////////////////////////////////

void delay (unsigned int del_time) 
{ 
  unsigned long i,j;
  
  for(j = 0; j<5; j++)
    for(i = 0; i < del_time; i++);	   
}								    							    

void LEDOn(int led)
{
  PORTC |= _BV(led);
}

void LEDOff(int led)
{
  PORTC &=  ~_BV(led);
}